if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
	SWEP.HoldType			= "ar2"
	
end

if ( CLIENT ) then

	SWEP.PrintName					= "SAKO TRG"			
	SWEP.Author					= "Mighty Lolrus"
	SWEP.Slot					= 4
	SWEP.SlotPos					= 5
	SWEP.IconLetter					= "r"
	SWEP.WeaponSelectIconLetter			= "r"
	SWEP.DrawAmmo					= true
	SWEP.DrawWeaponInfoBox				= true
	SWEP.BounceWeaponIcon				= true
	SWEP.SwayScale					= 1.0
	SWEP.BobScale					= 1.0
	SWEP.WepSelectIcon				= surface.GetTextureID( "weapons/swep" )

	SWEP.ViewModelFlip				= true
	SWEP.CSMuzzleFlashes				= true

	killicon.AddFont( "awp", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )	
end

SWEP.Base				= "weapon_erc_base"
SWEP.Category                 = "Mighty's Requests"
SWEP.Instructions             = "Credits:Model: Darkstorn, Uvmaps: Darkstorn, dreadus, TheLama, Sounds: Vunsunta, Skin/Animations/Compiles/Scope smoothing/Normals: SilentAssassin12, Lua coding/reload,draw sounds: Mighty Lolrus."                 
SWEP.Spawnable				= true
SWEP.AdminSpawnable			= true

SWEP.ViewModel				= "models/weapons/v_snip_trg.mdl"
SWEP.WorldModel				= "models/weapons/w_snip_scout.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo			= false
SWEP.AutoSwitchFrom			= false

SWEP.ShakeWeaponSelectIcon      	= false

SWEP.InfiniteAmmo                       = false
SWEP.UseScope                           = true
SWEP.WeaponDeploySpeed                  = 1

SWEP.ZoomedPrimaryAutomatic             = false
SWEP.ZoomedPrimaryDelay                 = 1.1
SWEP.ZoomedPrimaryCone                  = 0.013
SWEP.ZoomedPrimaryDamage                = 134
SWEP.ZoomedPrimaryRecoil                = 0.2
SWEP.ZoomedTracerFreq                   = 0
SWEP.ZoomedDrawCrosshair		= false

SWEP.Primary.BulletForce                = "7"
SWEP.Primary.Sound			= Sound( "weapons/weapon_sak/sak-1.wav" )
SWEP.Primary.NumShots		= 1
SWEP.Primary.ClipSize		= 10
SWEP.Primary.DefaultClip	= 50
SWEP.Primary.Ammo			= "ar2"



SWEP.UnzoomedPrimaryAutomatic           = false
SWEP.UnzoomedPrimaryDelay               = 1.1
SWEP.UnzoomedPrimaryCone                = 0.269
SWEP.UnzoomedPrimaryDamage              = 134
SWEP.UnzoomedPrimaryRecoil              = 0.6
SWEP.UnzoomedTracerFreq                 = 1
SWEP.UnzoomedDrawCrosshair		= false

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

function SWEP:Deploy()
        self.Primary.Automatic = self.UnzoomedPrimaryAutomatic
        self.Primary.Delay = self.UnzoomedPrimaryDelay
        self.Primary.Cone = self.UnzoomedPrimaryCone
        self.Primary.Damage = self.UnzoomedPrimaryDamage
        self.Primary.Recoil = self.UnzoomedPrimaryRecoil
        self.TracerFreq = self.UnzoomedTracerFreq
	self.DrawCrosshair = self.UnzoomedDrawCrosshair
        self.ScopeLevel = 0
	self.Weapon:SetNetworkedBool( "Zoomed", false )
        self.Weapon:EmitSound( Sound( self.Primary.WeaponDrawSound ) )
	return true
end

function SWEP:DrawHUD()

	if ( self.Weapon:GetNetworkedBool( "Ironsights" ) ) then return end

	local x = ScrW() / 2.0
	local y = ScrH() / 2.0
	local scale = 10 * self.Primary.Cone

	local LastShootTime = self.Weapon:GetNetworkedFloat( "LastShootTime", 0 )
	scale = scale * (2 - math.Clamp( (CurTime() - LastShootTime) * 5, 0.0, 1.0 ))
	
	surface.SetDrawColor( 0, 200, 215, 255 )

	local gap = 40 * scale
	local length = gap + 20 * scale
	surface.DrawLine( x - length, y, x - gap, y )
	surface.DrawLine( x + length, y, x + gap, y )
	surface.DrawLine( x, y - length, x, y - gap )
	surface.DrawLine( x, y + length, x, y + gap )

	if ( self.Weapon:GetNetworkedBool( "Zoomed" ) ) then
		surface.SetDrawColor( 0, 0, 0, 255 )
		surface.DrawLine( 0, y, ScrW(), y )
		surface.DrawLine( x, 0, x, ScrH() )
		surface.SetTexture(surface.GetTextureID("weapons/scopes/scope_frontline"))
		surface.SetDrawColor( 255, 255, 255, 255 )
		surface.DrawTexturedRect( x - (ScrH() / 2), 0, ScrH(), ScrH() )
		surface.SetDrawColor( 0, 0, 0, 255 )
		surface.DrawRect(0, 0, x - (ScrH() / 2), ScrH() )
		surface.DrawRect(x + (ScrH() / 2), 0, ScrW() - (x + (ScrH() / 2)), ScrH() )
	end

end

function SWEP:SetZoomed( b )

	self.Weapon:SetNetworkedBool( "Zoomed", b )

end

function SWEP:Initialize()

	if ( SERVER ) then
		self:SetWeaponHoldType( self.HoldType )
		self:SetNPCMinBurst( 30 )
		self:SetNPCMaxBurst( 30 )
		self:SetNPCFireRate( 0.01 )
	end

        self.Primary.Automatic = self.UnzoomedPrimaryAutomatic
        self.Primary.Delay = self.UnzoomedPrimaryDelay
        self.Primary.Cone = self.UnzoomedPrimaryCone
        self.Primary.Damage = self.UnzoomedPrimaryDamage
        self.Primary.Recoil = self.UnzoomedPrimaryRecoil
        self.TracerFreq = self.UnzoomedTracerFreq
	self.DrawCrosshair = self.UnzoomedDrawCrosshair
        self.ScopeLevel = 0

        self.Weapon:SetDeploySpeed( self.WeaponDeploySpeed )

	self.Weapon:SetNetworkedBool( "Zoomed", false )

	self.Weapon:SetNetworkedBool( "Ironsights", false )

end

function SWEP:AdjustMouseSensitivity()
	if self.ScopeLevel == 0 then
		return -1
	end
	if self.ScopeLevel == 1 then
		return 0.1
	end
	if self.ScopeLevel == 2 then
		return 0.001
	end
end

SWEP.NextSecondaryAttack = 0

function SWEP:SecondaryAttack()

        if (self.UseScope == true) then
                if(self.ScopeLevel == 0) then
                        self.Primary.Automatic = self.ZoomedPrimaryAutomatic
                        self.Primary.Delay = self.ZoomedPrimaryDelay
                        self.Primary.Cone = self.ZoomedPrimaryCone
                        self.Primary.Damage = self.ZoomedPrimaryDamage
                        self.Primary.Recoil = self.ZoomedPrimaryRecoil
                        self.TracerFreq = self.ZoomedTracerFreq
			self.DrawCrosshair = self.ZoomedDrawCrosshair
                        if (SERVER) then
                                self.OriginalFOV = self.Owner:GetFOV()
                                self.Owner:SetFOV( 25, 0.3 )
                        end
			self.Weapon:EmitSound( Sound( "Default.Zoom" ) )
			self:SetZoomed(true)
                        self.ScopeLevel = 1
                else if(self.ScopeLevel == 1) then
                        self.Primary.Automatic = self.ZoomedPrimaryAutomatic
                        self.Primary.Delay = self.ZoomedPrimaryDelay
                        self.Primary.Cone = self.ZoomedPrimaryCone
                        self.Primary.Damage = self.ZoomedPrimaryDamage
                        self.Primary.Recoil = self.ZoomedPrimaryRecoil
                        self.TracerFreq = self.ZoomedTracerFreq
			self.DrawCrosshair = self.ZoomedDrawCrosshair
                        if (SERVER) then
                                self.Owner:SetFOV( 15, 0.2 )
                        end
			self.Weapon:EmitSound( Sound( "Default.Zoom" ) )
			self:SetZoomed(true)
                        self.ScopeLevel = 2
                else
                        self.Primary.Automatic = self.UnzoomedPrimaryAutomatic
                        self.Primary.Delay = self.UnzoomedPrimaryDelay
                        self.Primary.Cone = self.UnzoomedPrimaryCone
                        self.Primary.Damage = self.UnzoomedPrimaryDamage
                        self.Primary.Recoil = self.UnzoomedPrimaryRecoil
                        self.TracerFreq = self.UnzoomedTracerFreq
			self.DrawCrosshair = self.UnzoomedDrawCrosshair
                        if (SERVER) then
                                self.Owner:SetFOV( self.OriginalFOV, 0.3 )
                        end
			self.Weapon:EmitSound( Sound( "Default.Zoom" ) )
			self:SetZoomed(false)
                        self.ScopeLevel = 0
                        end
                end
        end

	if ( !self.IronSightsPos ) then return end
	if ( self.NextSecondaryAttack > CurTime() ) then return end
	
	bIronsights = !self.Weapon:GetNetworkedBool( "Ironsights", false )
	
	self:SetIronsights( bIronsights )
	
	self.NextSecondaryAttack = CurTime() + 0.3
	
end

function SWEP:SetZoomed( b )

	self.Weapon:SetNetworkedBool( "Zoomed", b )

end




function SWEP:Reload()

	self.Weapon:DefaultReload(ACT_VM_RELOAD) 
	

	if ( self.Weapon:Clip1() < self.Primary.ClipSize ) and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
	-- When the current clip < full clip and the rest of your ammo > 0, then



		self:SetIronsights(false)
		
self.Weapon:EmitSound("weapons/weapon_sak/reload.wav")
end
	
end

function SWEP:Deploy()

	self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
      self.Weapon:EmitSound("weapons/weapon_sak/draw.wav")
	self.Reloadaftershoot = CurTime() + 1
	self.Weapon:SetNextPrimaryFire(CurTime() + 1)

	return true
end



function SWEP:DrawHUD()

	// No crosshair when ironsights is on
	if ( self.Weapon:GetNetworkedBool( "Ironsights" ) ) then return end

	local x = ScrW() / 2.0
	local y = ScrH() / 2.0
	local scale = 10 * self.Primary.Cone
	
	
	local LastShootTime = self.Weapon:GetNetworkedFloat( "LastShootTime", 0 )
	scale = scale * (2 - math.Clamp( (CurTime() - LastShootTime) * 5, 0.0, 1.0 ))
	
	surface.SetDrawColor( 255, 255, 255, 255 )
	
	
	local gap = 40 * scale
	local length = gap + 20 * scale
	surface.DrawLine( x - length, y, x - gap, y )
	surface.DrawLine( x + length, y, x + gap, y )
	surface.DrawLine( x, y - length, x, y - gap )
	surface.DrawLine( x, y + length, x, y + gap )
		
		if ( self.Weapon:GetNetworkedBool( "Zoomed" ) ) then
		surface.SetDrawColor( 0, 0, 0, 255 )
		surface.DrawLine( 0, y, ScrW(), y )
		surface.DrawLine( x, 0, x, ScrH() )
		surface.SetTexture(surface.GetTextureID("weapons/scopes/scope_thermal"))
		surface.SetDrawColor( 255, 255, 255, 255 )
		surface.DrawTexturedRect( x - (ScrH() / 2), 0, ScrH(), ScrH() )
		surface.SetDrawColor( 0, 0, 0, 255 )
		surface.DrawRect(0, 0, x - (ScrH() / 2), ScrH() )
		surface.DrawRect(x + (ScrH() / 2), 0, ScrW() - (x + (ScrH() / 2)), ScrH() )
	end

end

